 unit GraphMPP;
 { ᪨ 
 }
   interface
    uses  Crt, Graph, KeyStrok, Windows,  Messages, WindMPP, Cursors ;

   type
         func=function(x:real):real;
         scl=array[1..8] of real;
   type
      RealPointType=record
             x,y :real;
             ix,iy:integer;
             end;

   var
       pointVectrX,pointVectrY :integer;
       TraceOldTB,TraceOldT, TraceOldTl, graFunOld, graArrOldG,
       GraOldRol, histoldH           : array[0..600] of integer;
       GraOldRol1,GraOldROL2         : array[0..600] of integer;
       cursorsvar:cursor;
   procedure scale (xmin,xmax,ymin,ymax:real;var s:scl);
   procedure axes(t1,t2:string; color:word; s:scl);
   procedure point(x,y:real;color:word; var s:scl);
   procedure pointB(x,y:real;Color:integer;var s:scl);
   procedure PenTo(x,y:real; var s:scl);
   procedure circw(x,y,r:real;color:word; var s:scl);
   procedure vectr(x,y:real;color:word; var s:scl);
   procedure Trace(size:integer;var x,y;color:integer;var s:scl);
   procedure TraceB(size:integer;var x,y;color:integer;var s:scl);
   procedure TraceL(size:integer;var x,y;color:integer;var s:scl);
   procedure GraFun(size:integer;f:func;x1,x2:real;color:integer;var s:scl);
   procedure GraArr(size:integer;var New;color:integer; var s:scl);
   procedure Roll(y:real; color:integer;  s:scl);
   procedure RollRight(y:real; color:integer; s:scl);
   procedure RollDown(x:real; color:integer; s:scl);
   procedure RollUp(x:real; color:integer; s:scl);
   procedure Roll2(y1:real; color1:integer;  s1:scl;
                   y2:real; color2:integer;  s2:scl);
   procedure HistDraw(NChannals:integer; var w; wmax:real;color:integer);
   procedure HistChannels(NEvents:integer; var x; xmin,xmax:real;
                           NChannels:integer; var w;var ih:integer);
   procedure Orbit(n:integer; x,y:real;
        Color:integer;TraceColor:integer; var OldO; var s:scl);
   procedure OrbitSector(n:integer; x,y:real;
             BakColor,SectorColor,TraceColor:integer; var OldO; var s:scl);
   procedure PointMotion(x,y:real; color:integer;
                    var  OldX,OldY,newColor:integer;s:scl);
  procedure vectrMotion(var a,b:RealPointType;
                      color:integer;s:scl);
  procedure vectMotion(var a,b:RealPointType;s:scl);
  procedure Cross( var x,y :real; s: scl);

 Implementation

       type
         rearray=array[1..2] of real;
         intarray=array[0..2] of integer;

{$R-}
  procedure scale (xmin,xmax,ymin,ymax:real;var s:scl);
   var xm,ym: integer;
       begin
{       SelectWindow(MainWindow);}
         with CurWindow^ do
          begin
             xm:=x2-x1; ym:=y2-y1;
          end;
           s[1]:=xm/(xmax-xmin);

	   s[3]:=-ym/(ymax-ymin);
	   s[2]:=-s[1]*xmin;
	   s[4]:=ym-s[3]*ymin;
           s[5]:=xmin; s[6]:=xmax;
           s[7]:=ymin; s[8]:=ymax;
       end;



   procedure PenTo(x,y:real; var s:scl);
   begin
{    SelectWindow(MainWindow);}
	pointVectrX:=trunc(s[1]*x+s[2]);pointVectrY:=trunc(s[3]*y+s[4]);
	MoveTo(pointVectrX,pointVectrY);
   end;


   procedure axes(t1,t2:string; color:word; s:scl);
    var x,y,th,tw,h,w:integer;
      begin
{           SelectWindow(MainWindow);}
           th:=TextHeight(t2);
           tw:=TextWidth(t1);
           SetColor(color);
           SetTextStyle(DefaultFont,HorizDir,1);
           x:=round(s[2]); y:=round(s[3]*s[8]+s[4]);
           MoveTo(x,y);
           LineTo(x,round(s[3]*s[7]+s[4]));
           x:=x+4;
           y:=y+4;
           OutTextXY(x,y,t2);
           x:=round(s[1]*s[6]+s[2]); y:=round(s[4]);
           MoveTo(x,y); LineTo(round(s[1]*s[5]+s[2]),y);
           x:=x-tw-2;
           y:=y-2-TextHeight(t1);  OutTextXY(x,y,t1);
     end;


  procedure point(x,y:real;color:word; var s:scl);
    var  ix,iy:integer;
  begin
{     SelectWindow(MainWindow);        }

      ix:=trunc(s[1]*x+s[2]);
     if (y<s[8]) then
     iy:=trunc(s[3]*y+s[4])
     else iy:=trunc(s[3]*s[8]+s[4]);
     putpixel(ix,iy,color);
     pointVectrX:=ix; pointVectrY:=iy;
   end;
procedure pointB(x,y:real;Color:integer;var s:scl);
begin
   penTo(x,y,s);
   PutPixel(Getx+1,Gety,Color);
   PutPixel(Getx-1,Gety,Color);
   PutPixel(Getx,Gety+1,Color);
   PutPixel(Getx,Gety-1,Color);
end;

   procedure circw(x,y,r:real;color:word; var s:scl);
    var  ix,iy,ir:integer;
  begin
 {    SelectWindow(MainWindow);}
     ix:=trunc(s[1]*x+s[2]);
     iy:=trunc(s[3]*y+s[4]);
     ir:=trunc(s[1]*r);
     SetColor(color); Circle(ix,iy,ir);
   end;

   procedure vectr(x,y:real;color:word; var s:scl);
       var ix,iy:integer;
     begin
{       SelectWindow(MainWindow);  }
       MoveTo(pointVectrX,pointVectrY);
       SetColor(color);
       ix:=trunc(s[1]*x+s[2]);
       iy:=trunc(s[3]*y+s[4]);
       LineTo(ix,iy);
       pointVectrX:=ix;
       pointVectrY:=iy;
    end;

  procedure trace(size:integer;var x,y;color:integer;var s:scl);
       var
         colorp,i,j,bc:integer;
       begin
 {        SelectWindow(MainWindow);}
         bc:=CurWindow^.BkCol;
         colorp:=abs(color);
         if color <0 then
          begin j:=1;
	    for i:=1 to TraceOldT[0] do
            begin
	      putpixel(TraceOldT[j],TraceOldT[j+1],bc);
              j:=j+2;
            end;
          end;
            j:=1;
            for i:=1 to size do
	      begin
	        TraceOldT[j]:=trunc(s[1]*rearray(x)[i]+s[2]);
	        TraceOldT[j+1]:=trunc(s[3]*rearray(y)[i]+s[4]);
	        putpixel(TraceOldT[j],TraceOldT[j+1],colorp);
                j:=j+2;
              end;
        TraceOldT[0]:=size;
       end;

   procedure TraceL(size:integer;var x,y;
                 color:integer; var s:scl);

       var
         colorp,i,j,bc,tline,wline:integer;
       begin
{         SelectWindow(MainWindow);  }
         SetLineStyle(0,0,3);
         bc:=CurWindow^.BkCol;
         colorp:=abs(color);
         SetColor(bc);
         if color <0 then
          begin j:=3;
            MoveTo(TraceOldTl[1],TraceOldTl[2]);
	    for i:=2 to TraceOldTl[0] do
            begin
	      LineTo(TraceOldTl[j],TraceOldTl[j+1]);
              j:=j+2;
            end;
          end;
{        SetLineStyle(tline,0,wline);}
        SetColor(colorp);
        TraceOldTl[1]:=trunc(s[1]*rearray(x)[1]+s[2]);
        TraceOldTl[2]:=trunc(s[3]*rearray(y)[1]+s[4]);
        MoveTo(TraceOldTl[1],TraceOldTl[2]);
            j:=3;
            for i:=2 to size do
	      begin
	        TraceOldTl[j]:=trunc(s[1]*rearray(x)[i]+s[2]);
	        TraceOldTl[j+1]:=trunc(s[3]*rearray(y)[i]+s[4]);
	        LineTo(TraceOldTl[j],TraceOldTl[j+1]);
                j:=j+2;
              end;
       TraceOldTl[0]:=size;
       end;
procedure traceB(size:integer;var x,y;color:integer;var s:scl);
var
   colorp,i,j,bc:integer;
begin
         bc:=CurWindow^.BkCol;
         colorp:=abs(color);
         if color <0 then
          begin j:=1;
	    for i:=1 to TraceOldTB[0] do
            begin
	      putpixel(TraceOldTB[j]+1,TraceOldTB[j+1],bc);
	      putpixel(TraceOldTB[j]-1,TraceOldTB[j+1],bc);
	      putpixel(TraceOldTB[j],TraceOldTB[j+1]+1,bc);
	      putpixel(TraceOldTB[j],TraceOldTB[j+1]-1,bc);
              j:=j+2;
            end;
          end;
            j:=1;
            for i:=1 to size do
	      begin
	        TraceOldTB[j]:=trunc(s[1]*rearray(x)[i]+s[2]);
	        TraceOldTB[j+1]:=trunc(s[3]*rearray(y)[i]+s[4]);
	        putpixel(TraceOldTB[j]+1,TraceOldTB[j+1],colorp);
	        putpixel(TraceOldTB[j]-1,TraceOldTB[j+1],colorp);
	        putpixel(TraceOldTB[j],TraceOldTB[j+1]+1,colorp);
	        putpixel(TraceOldTB[j],TraceOldTB[j+1]-1,colorp);
                j:=j+2;
              end;
        TraceOldTB[0]:=size;
end;
  procedure grafun(size:integer;f:func;x1,x2:real;color:integer;var s:scl);
     var
        dx,x,y,xl,xr      : real;
        bc,i,j,col        :integer;
     begin
{     SelectWindow(MainWindow);}
     col:=abs(color);
        bc:=CurWindow^.BkCol;
        if x1>s[5] then xl:=x1 else xl:=s[5];
        if x2<s[6] then xr:=x2 else xr:=s[6];
        dx:=(xr-xl)/size;
        x:=xl;
        if (color<0) then
        begin
         SetColor(bc);
         j:=3; MoveTo(GraFunOld[1],GraFunOld[2]);
         for i:=2 to GraFunOld[0] do
          begin
           LineTo(GraFunOld[j],graFunOld[j+1]);
           j:=j+2;
          end;
         end;
              SetColor(col);
             GraFunOld[1]:=trunc(s[1]*x+s[2]);
             GraFunOld[2]:=trunc(s[3]*f(x)+s[4]);
            j:=3; MoveTo(GraFunOld[1],GraFunOld[2]);
           for i:=2 to size do
           begin
              x:=x+dx;
              GraFunOld[j]:=trunc(s[1]*x+s[2]);
              GraFunOld[j+1]:=trunc(s[3]*f(x)+s[4]);
              LineTo(GraFunOld[j],GraFunOld[j+1]);
              j:=j+2;
           end;
        GraFunOld[0]:=size;
     end;

   procedure GraArr(size:integer;var New;color:integer;var s:scl);
      var k,m,bc,col:integer; x,h:real;

    begin
{       SelectWindow(MainWindow); }
       bc:=CurWindow^.bkcol; col:=abs(color);
      if color<0 then
        begin  m:=2*GraArrOldG[0]; k:=1;
          repeat
           PutPixel(GraArrOldG[k],GraArrOldG[k+1],bc);
           k:=k+2;
          until k>m;
        end;

     h:=GetWidth(CurWindow);
     if size>1 then h:=h/(size-1);
     m:=1; x:=0.0;
     for k:=1 to size do
      begin
       GraArrOldG[m]:=trunc(x);
       GraArrOldG[m+1]:=trunc(s[3]*ReArray(New)[k]+s[4]);
       PutPixel(GraArrOldG[m],GraArrOldG[m+1],col);
       m:=m+2; x:=x+h;
      end;
     GraArrOldG[0]:=size;
    end;


{    procedure Roll(y:real; color:integer; s:scl);
    var bc,i,m,j,l,k :integer;
    begin
      SelectWindow(MainWindow);
       l:=GetWidth(CurWindow); bc:=CurWindow^.BkCol;
       k:=GraOldRol[0];
       if k=0   then
       begin
        for i:=1 to l do GraOldRol[i]:=3000;
        k:=1;
       end;
        GraOldRol[k]:=trunc(s[3]*y+s[4]);
        j:=((k+1) mod l)+1;
       for i:=1 to l-1 do
        begin   PutPixel(i,GraOldRol[j],bc); j:=(j mod l)+1;
         PutPixel(i,GraOldRol[j],color);
        end;
         PutPixel(0,GraOldRol[j],bc);
         PutPixel(l-1,GraOldRol[succ(k)],bc);
         k:=(k mod l)+1;
        GraOldRol[0]:=k;
   end;
    procedure Roll2(y1:real; color1:integer; s1:scl;
                    y2:real; color2:integer; s2:scl);
    var bc,i,m,j,l,k :integer;
    begin
       SelectWindow(MainWindow);
       l:=GetWidth(CurWindow); bc:=CurWindow^.BkCol;
       k:=GraOldRol1[0];
       if k=0   then
       begin
        for i:=1 to l do GraOldRol1[i]:=maxint;
        k:=1;
       end;
        GraOldRol1[k]:=trunc(s1[3]*y1+s1[4]);
        j:=((k+1) mod l)+1;
       for i:=1 to l-1 do
        begin   PutPixel(i,GraOldRol1[j],bc); j:=(j mod l)+1;
         PutPixel(i,GraOldRol1[j],color1);
        end;
         PutPixel(0,GraOldRol1[j],bc);
         PutPixel(l-1,GraOldRol1[succ(k)],bc);
         k:=(k mod l)+1;
        GraOldRol1[0]:=k;
       k:=GraOldRol2[0];
       if k=0   then
       begin
        for i:=1 to l do GraOldRol2[i]:=maxint;
        k:=1;
       end;
        GraOldRol2[k]:=trunc(s2[3]*y2+s2[4]);
        j:=((k+1) mod l)+1;
       for i:=1 to l-1 do
        begin   PutPixel(i,GraOldRol2[j],bc); j:=(j mod l)+1;
         PutPixel(i,GraOldRol2[j],color2);
        end;
         PutPixel(0,GraOldRol2[j],bc);
         PutPixel(l-1,GraOldRol2[succ(k)],bc);
         k:=(k mod l)+1;
        GraOldRol2[0]:=k;
   end;}
procedure RollRight(y:real; color:integer; s:scl);
var
   bc,i,m,j,l,k :integer;
begin
       l:=GetWidth(CurWindow)-1; { ᫮ ७ 祪 }
       bc:=CurWindow^.BkCol;
       k:=GraOldRol[0];
       if k=0   then begin
           for i:=1 to l do GraOldRol[i]:=3000;
           k:=1;
       end;
       PutPixel(1,GraOldRol[k],bc); { erase }
       GraOldRol[k]:=trunc(s[3]*y+s[4]);
       j:=(k mod l)+1;
       for i:=l-1 downto 1 do begin
            PutPixel(i,GraOldRol[j],bc); { erase }
            j:=(j mod l)+1;             { 㢥祭   j }
            PutPixel(i,GraOldRol[j],color);
            
       end;
       k:=(k mod l)+1;        { 㢥祭   k }
       GraOldRol[0]:=k;
end;
procedure Roll(y:real; color:integer; s:scl);
var
   bc,i,m,j,l,k :integer;
begin
       l:=GetWidth(CurWindow)-1; { ᫮ ७ 祪 }
       bc:=CurWindow^.BkCol;
       k:=GraOldRol[0];
       if k=0   then begin
           for i:=1 to l do GraOldRol[i]:=3000;
           k:=1;
       end;
       PutPixel(l,GraOldRol[k],bc); { erase }
       GraOldRol[k]:=trunc(s[3]*y+s[4]);
       j:=(k mod l)+1;
       for i:=1 to l-1 do begin
            PutPixel(i,GraOldRol[j],bc); { erase }
            j:=(j mod l)+1;             { 㢥祭   j }
            PutPixel(i,GraOldRol[j],color);
            
       end;
       k:=(k mod l)+1;        { 㢥祭   k }
       GraOldRol[0]:=k;
end;

procedure RollUp(x:real; color:integer; s:scl);
var 
   bc,i,m,j,l,k :integer;
begin
       l:=GetHeight(CurWindow)-1; { ᫮ ७ 祪 }
       bc:=CurWindow^.BkCol;
       k:=GraOldRol[0];
       if k=0   then begin
           for i:=1 to l do GraOldRol[i]:=3000;
           k:=1;
       end;
       PutPixel(GraOldRol[k],l,bc); { erase }
       GraOldRol[k]:=trunc(s[1]*x+s[2]);
       j:=(k mod l)+1;
       for i:=1 to l-1 do begin
            PutPixel(GraOldRol[j],i,bc); { erase }
            j:=(j mod l)+1;             { 㢥祭   j }
            PutPixel(GraOldRol[j],i,color);
            
       end;
       k:=(k mod l)+1;        { 㢥祭   k }
       GraOldRol[0]:=k;
end;
procedure RollDown(x:real; color:integer; s:scl);
var 
    bc,i,m,j,l,k :integer;
begin
       l:=GetHeight(CurWindow)-1; { ᫮ ७ 祪 }
       bc:=CurWindow^.BkCol;
       k:=GraOldRol[0];
       if k=0   then begin
           for i:=1 to l do GraOldRol[i]:=3000;
           k:=1;
       end;
       PutPixel(GraOldRol[k],1,bc); { erase }
       GraOldRol[k]:=trunc(s[1]*x+s[2]);
       j:=(k mod l)+1;
       for i:=l-1 downto 1 do begin
            PutPixel(GraOldRol[j],i,bc); { erase }
            j:=(j mod l)+1;             { 㢥祭   j }
            PutPixel(GraOldRol[j],i,color);
            
       end;
       k:=(k mod l)+1;        { 㢥祭   k }
       GraOldRol[0]:=k;
end;
    procedure Roll2(y1:real; color1:integer; s1:scl;
                    y2:real; color2:integer; s2:scl);
    var bc,i,m,j,l,k :integer;
    begin
       
       l:=GetWidth(CurWindow); bc:=CurWindow^.BkCol;
       k:=GraOldRol1[0];
       if k=0   then
       begin
        for i:=1 to l do GraOldRol1[i]:=maxint;
        k:=1;
       end;
        GraOldRol1[k]:=trunc(s1[3]*y1+s1[4]);
        j:=((k+1) mod l)+1;
       for i:=1 to l-1 do
        begin   PutPixel(i,GraOldRol1[j],bc); j:=(j mod l)+1;
         PutPixel(i,GraOldRol1[j],color1);
        end;
         PutPixel(0,GraOldRol1[j],bc);
         PutPixel(l-1,GraOldRol1[succ(k)],bc);
         k:=(k mod l)+1;
        GraOldRol1[0]:=k;
       k:=GraOldRol2[0];
       if k=0   then
       begin
        for i:=1 to l do GraOldRol2[i]:=maxint;
        k:=1;
       end;
        GraOldRol2[k]:=trunc(s2[3]*y2+s2[4]);
        j:=((k+1) mod l)+1;
       for i:=1 to l-1 do
        begin   PutPixel(i,GraOldRol2[j],bc); j:=(j mod l)+1;
         PutPixel(i,GraOldRol2[j],color2);
        end;
         PutPixel(0,GraOldRol2[j],bc);
         PutPixel(l-1,GraOldRol2[succ(k)],bc);
         k:=(k mod l)+1;
        GraOldRol2[0]:=k;
   end;

  procedure HistChannels(NEvents:integer; var x; xmin,xmax:real;
                              NChannels:integer; var w;var ih:integer);
(* NEvents ᮡ⨩ ।  NChannels  ⮣ࠬ *)
       var i,k:integer; xx, h:real;
  begin
      h:=NChannels/(xmax-xmin);
      if (ih=1) or (ih=2) then
          for k:=1 to NChannels do ReArray(w)[k]:=0.0;
      if ih=2 then ih:=3;
      for i:=1 to NEvents do
       begin
         xx:=ReArray(x)[i];
         if (xmin<=xx) and (xx<xmax) then
           begin
              k:=trunc((xx-xmin)*h)+1;
              ReArray(w)[k]:=ReArray(w)[k]+1.0;
           end;
       end;
  end;

procedure Orbit(n:integer; x,y:real;
        Color:integer;TraceColor:integer; var OldO; var s:scl);
   { IntArray(OldO)[0] - ⢮ 뢥  ࠭ 祪.
    ࢮ 饭  Orbit   뢠饩 ணࠬ
   OldO[0]:=0 . newColor= 0 ᫥ ࠥ,  - ४-
   訢  }
   var i,j      : integer;
  begin
 {   SelectWindow(MainWindow);}
    i:=intarray(oldO)[0];
    if i>0
     then
       begin
         PutPixel(intarray(oldO)[i-1],intarray(oldO)[i],TraceColor);
         intarray(oldO)[i-1]:=trunc(s[1]*x+s[2]);
         intarray(oldO)[ i ]:=trunc(s[3]*y+s[4]);
         PutPixel(intarray(oldO)[i-1],intarray(oldO)[i],color);
       end
     else
         for j:=1 to 2*n do intarray(oldO)[j]:=maxInt;
    intarray(oldO)[0]:=(i mod (2*n))+2;
  end;

procedure OrbitSector(n:integer; x,y:real;
      BakColor,SectorColor,TraceColor:integer; var OldO; var s:scl);
   { IntArray(old)[0] - ⢮ 뢥  ࠭ 祪.
    ࢮ 饭  Orbit   뢠饩 ணࠬ
   OldO[0]:=0 . newColor= 0 ᫥ ࠥ,  - ४-
   訢  }
   var i,j ,k,l     : integer;
  begin
{    SelectWindow(MainWindow);  }
    i:=intarray(oldO)[0];     k:=trunc(s[2]); l:=trunc(s[4]);
    if i>0
     then
       begin
         MoveTo(k,l); SetColor( BakColor);
         LineTo(intarray(oldO)[i-1],intarray(oldO)[i]);
         SetColor(TraceColor);
         PutPixel(intarray(oldO)[i-1],intarray(oldO)[i],TraceColor);
         intarray(oldO)[i-1]:=trunc(s[1]*x+s[2]);
         intarray(oldO)[ i ]:=trunc(s[3]*y+s[4]);
         MoveTo(k,l); SetColor(SectorColor);
         LineTo(intarray(oldO)[i-1],intarray(oldO)[i]);

       end
     else
         for j:=1 to 2*n do intarray(oldO)[j]:=maxInt;
    intarray(oldO)[0]:=(i mod n)+2;
  end;

  procedure PointMotion(x,y:real; color:integer;
                    var  OldX,OldY,newColor:integer;s:scl);
  (* 뢮 窠  न⠬ x,y , 뢥
   ।饬 饭  ணࠬ ࠥ (᫨
  newColor<0 )    訢 梥⮬ newColor.
   砫  oldX  oldY ࠢ묨,᪠, 10000   *)
     var nc,ix,iy:integer;
   begin
 {    SelectWindow(MainWindow);}
     ix:=trunc(s[1]*x+s[2]); iy:=trunc(s[3]*y+s[4]);
     PutPixel(ix,iy,color);
     if newColor<0 then nc:=CurWindow^.bkCol
                   else nc:=newColor;
     if ((OldX<>ix)  or (OldY<>iy))
         then
           begin
              PutPixel(oldX,oldY,nc);
              oldX:=ix; oldY:=iy;
           end;
     end;

   procedure HistDraw(NChannals:integer; var w; wmax: real;
                                         color:integer);
     var bc,i,j,col:integer;  x,d:real; s :scl;
     begin
{     SelectWindow(MainWindow);  }
     Scale(0.0,1.0,0.0,wmax,s);
     col:=abs(color);
        bc:=CurWindow^.BkCol;
        if (color<0) then
        begin
            SetColor(bc);
               j:=2; MoveTo(histOldH[2],histOldH[1]);
               for i:=1 to 2*histOldH[0] do
                   begin
                     LineTo(histOldH[j],histOldH[j+1]);
                     j:=j+2;
                   end;
               LineTo(histOldH[j-1],histOldH[1]);
         end;
         d:=1.0/NChannals; x:=0.0;
         j:=2; histOldH[1]:=trunc(s[4]);
         MoveTo(trunc(s[2]),histOldH[1]);
         SetColor(col);
         for i:=1 to NChannals do
           begin
              histOldH[j]:=trunc(s[1]*x+s[2]);

			  histOldH[j+1]:=trunc(s[3]*ReArray(w)[i]+s[4]);
              LineTo(histOldH[j],histOldH[j+1]);
              x:=x+d;
              histOldH[j+2]:=trunc(s[1]*x+s[2]);
              histOldH[j+3]:=histOldH[j+1];
              LineTo(histOldH[j+2],histOldH[j+1]);
              j:=j+4;
           end;
              LineTo(histOldH[j-2],histOldH[1]);
        histOldH[0]:=NChannals;
     end;
  procedure vectrMotion(var a,b:RealPointType;
                      color:integer;s:scl);
  var ax,ay,bx,by: integer;
    begin
     ax:=trunc(s[1]*a.x+s[2]);
     ay:=trunc(s[3]*a.y+s[4]);
     bx:=trunc(s[1]*b.x+s[2]);
     by:=trunc(s[3]*b.y+s[4]);
           MoveTo(a.ix,a.iy);
           setcolor(0);
           LineTo(b.ix,b.iy);
           MoveTo(ax,ay);
           setcolor(color);
           LineTo(bx,by);
              a.ix:=ax;
              a.iy:=ay;
              b.ix:=bx;
              b.iy:=by;
     end;

  procedure vectMotion(var a,b:RealPointType;s:scl);
  var ax,ay,bx,by: integer;
    begin
     ax:=trunc(s[1]*a.x+s[2]);
     ay:=trunc(s[3]*a.y+s[4]);
     bx:=trunc(s[1]*b.x+s[2]);
     by:=trunc(s[3]*b.y+s[4]);
           MoveTo(a.ix,a.iy);
           setcolor(0);
           LineTo(b.ix,b.iy);
           MoveTo(ax,ay);
           setcolor(Red);
           LineTo(bx,by);
              a.ix:=ax;
              a.iy:=ay;
              b.ix:=bx;
              b.iy:=by;
     end;

procedure Cross( var x,y :real; s: scl);
       var ix,iy :word;
begin
 if (AltCheckKey=F2Key) or (AltCheckKey=F3Key) then
  begin
    if (AltCheckKey=F3Key) then
      begin
        cursorsvar^.x:=trunc(s[1]*x+s[2]);
        cursorsvar^.y:=trunc(s[3]*y+s[4]);
      end;
    GetCursor(curWindow, cursorsvar, ix, iy);
    x:=(ix-s[2])/s[1];
    y:=(iy-s[4])/s[3];
    AltCheckKey:=0;
  end;
end;


     var j :integer;
     begin
      for j:=1 to 500 do
       begin
        TraceOldT[j]:=maxInt;TraceOldTl[j]:=maxInt;
        GraFunOld[j]:=maxInt;TraceOldTB[j]:=maxInt;
        GraArrOldG[j]:=maxInt; graOldRol[j]:=maxInt; histOldH[j]:=maxInt;
       end;
        cursorsvar:=Xcursor(15,8);
        TraceOldT[0]:=0; TraceOldTl[0]:=0;TraceOldTB[0]:=0;
        GraFunOld[0]:=0; GraoldRol[0]:=0;
        GraoldRol1[0]:=0; GraoldRol2[0]:=0;
        HistoldH[0]:=0; GraArrOldG[0]:=0; 
     end.
