        title   WritChar
        public  WritChar
        assume  cs:code
code    segment

;       WritChar(x,y:word; col:byte; var buf,font; num:byte)

x       equ     [bp+20]
y       equ     [bp+18]
col     equ     [bp+16]
buf     equ     [bp+12]
font    equ     [bp+8]
num     equ     [bp+6]

Multiplier      dw      80
CharHeight      dw      14
NextChar        equ     80*14-1

WritChar        proc    near
        push    bp
        push    ds
        mov     bp,sp
        mov     ax,0a000h       ;video buffer base
        mov     es,ax
        mov     ax,y
        mul     Multiplier
        mov     di,ax
        lds     si,buf
        cld
        mov     ax,x
        mov     bx,ax
        and     bx,7
        shr     ax,1
        shr     ax,1
        shr     ax,1
        add     di,ax

        mov     dx,3ceh
        mov     al,5
        out     dx,al
        inc     dx
        mov     al,2
        out     dx,al           ;set write mode 2
        mov     cx,num
        xor     ch,ch
                                ;hence:
                                ;       bl - number of rotations
                                ;       di - byte position
                                ;       cx - number of characters
                                ;       es - video buffer base
                                ;       ds:si - string buffer
                                ;       dx - pointer to EGA register
extloop:lodsb
        push    ds
        push    si
        push    cx
        lds     si,font
        mov     cx,CharHeight
        mul     cl
        add     si,ax
intloop:lodsb
        mov     bh,al           ;bh - saved scan line
        push    cx
        mov     cl,bl
        shr     al,cl
        mov     ch,al
        dec     dx
        mov     al,8
        out     dx,al
        mov     al,ch
        inc     dx
        out     dx,al
        mov     al,es:[di]
        mov     al,col
        mov     es:[di],al
        or      bl,bl
        jz      intend
        neg     cl
        add     cl,8
        shl     bh,cl
        dec     dx
        mov     al,8
        out     dx,al
        mov     al,bh
        inc     dx
        out     dx,al
        mov     al,es:[di+1]
        mov     al,col
        mov     es:[di+1],al
intend: pop     cx
        add     di,Multiplier
        loop    intloop
        sub     di,NextChar
        pop     cx
        pop     si
        pop     ds
        loop    extloop
        dec     dx
        mov     al,5
        out     dx,al
        inc     dx
        xor     al,al
        out     dx,al
        pop     ds
        pop     bp
        ret     16
WritChar        endp

code    ends
        end
